<?php
class PhotoTag extends CWidget
{
    /**
	 * Unique Image ID
	 */
	public $imageid;
    
	/**
	 * Image URL
	 */
	public $imageurl;
    
    /**
	 * Tag Box Height
	 */
	public $height;
    
    /**
	 * Tag Box Max Height
	 */
	public $maxHeight;
    
    /**
	 * Tag Box Width
	 */
	public $width;
    
    /**
	 * Tag Box Max Width
	 */
	public $maxWidth;
    
    /**
	 * Boolean Show Tag
	 */
	public $showTag;
    
    /**
	 * Boolean can Tag
	 */
	public $canTag;
    
    /**
	 * Boolean Show  Labels
	 */
	public $showLabels;
    
    /**
	 * call back save fucntion
	 */
	public $save;
    
    /**
	 * Boolean can Delete?
	 */
	public $canDelete;
    
    /**
	 * call back delete fucntion
	 */
	public $remove;
    
    /**
	 * already tagged
	 */
	public $defaultTags;
    
    /**
	 * Autocomplete list
	 */
	public $autoComplete;
    
    public $forceCopyAssets = false;

	protected $_assetsUrl;
	
	public function init()
	{
        // Initiliaze parameters
        if (empty($this->imageid)) $this->imageid = 'orgpic';
        if (empty($this->height)) $this->height = '100';
        if (empty($this->width)) $this->width = '100';
        if (empty($this->showTag)) $this->showTag = 'hover';
        if (empty($this->canTag)) $this->canTag = true;
        if (empty($this->showLabels)) $this->showLabels = false;
        if (empty($this->canDelete)) $this->canDelete = false;
        if (empty($this->save)) $this->save = '';//alert("tagged successfully");
        if (empty($this->remove)) $this->remove = '';//alert("removed successfully");
        if (empty($this->defaultTags)) $this->defaultTags = array();
        $this->defaultTags = json_encode($this->defaultTags);
        
        if (empty($this->autoComplete)) $this->autoComplete = array();
        $this->autoComplete = json_encode($this->autoComplete);
        
        // Add css files
		$cs = Yii::app()->clientScript;
		$cssFile = CHtml::asset(dirname(__FILE__).DIRECTORY_SEPARATOR.'assets/css'.DIRECTORY_SEPARATOR.'jquery.tag.css');
		$cs->registerCssFile($cssFile);
        
        $cssFile = CHtml::asset(dirname(__FILE__).DIRECTORY_SEPARATOR.'assets/css'.DIRECTORY_SEPARATOR.'jquery-ui.custom.css');
		$cs->registerCssFile($cssFile);
        
        // Add js files
        $jsFile = CHtml::asset(dirname(__FILE__).DIRECTORY_SEPARATOR.'assets/js'.DIRECTORY_SEPARATOR.'jquery-ui-1.9.2.custom.min.js');
		$cs->registerScriptFile($jsFile);
        
        $jsFile = CHtml::asset(dirname(__FILE__).DIRECTORY_SEPARATOR.'assets/js'.DIRECTORY_SEPARATOR.'jquery.tag.js');
		$cs->registerScriptFile($jsFile);
		
	}
	
	public function run()
	{
		echo '<img src="'.$this->imageurl.'" id="'.$this->imageid.'" border="0" />
            <script language="javascript">
            '.$this->js.'
            </script>';
	}
    
    /**
	 * Renders the contents of the <script> tag
	 *
	 * @return string
	 */
	public function getJs()
	{
		$ret = '$("#'.$this->imageid.'").tag({';
        $ret .= '   defaultWidth: '.$this->width.',
                    defaultHeight: '.$this->height.',
                    showTag: "'.$this->showTag.'",
                    canTag:'.$this->canTag.',
                    showLabels: '.$this->showLabels.',
                    canDelete: '.$this->canDelete.',
                    autoComplete: '.$this->autoComplete.',
                    defaultTags: '.$this->defaultTags.',
                    save: function(width, height, top_pos, left, label, the_tag) {';
                    if($this->save != '') {
                        $ret .= '$.post("'.$this->save.'", {"tag_x": left, "tag_y": top_pos, "height": height, "width": width, "title": label},
                        function(response) {
                            alert(response);
                        });';
                    }
                    
                    $ret .= '// once the ajax is done I need to get the ID here and then set it on the tag
                        the_tag.setId("someIdFromMyDb");
                    }';
        if($this->remove != '') {
            $ret .= ',remove: function(id){
                        $.post("'.$this->remove.'", {"id": id},
                        function(response) {
                            alert(response);
                        });
                    }';
        }
        if($this->maxHeight > $this->height) {
            $ret .= ',maxHeight: '.$this->maxHeight;
        }
        if($this->maxWidth > $this->width) {
            $ret .= ',maxWidth: '.$this->maxWidth;
        }
        
        $ret .= '});';
        return $ret;
	}
}
?>